"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var chai_1 = require("chai");
var _1 = require(".");
describe(__filename + "#", function () {
    it("can be created", function () {
        _1.parallel();
    });
    it("call a message against one entry", function () { return __awaiter(_this, void 0, void 0, function () {
        var i, fn;
        return __generator(this, function (_a) {
            i = 0;
            fn = _1.parallel(function (m) { return i++; });
            fn({}).next();
            fn({}).next();
            fn({}).next();
            chai_1.expect(i).to.equal(3);
            return [2 /*return*/];
        });
    }); });
    it("calls messages in parallel", function () { return __awaiter(_this, void 0, void 0, function () {
        var i, fn;
        return __generator(this, function (_a) {
            i = 0;
            fn = _1.parallel(function (m) { return i++; }, function (m) { return i++; }, function (m) { return i++; });
            fn({}).next();
            chai_1.expect(i).to.eql(3);
            return [2 /*return*/];
        });
    }); });
    it("calls a message against multiple functions", function () { return __awaiter(_this, void 0, void 0, function () {
        var i, fn, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    i = 0;
                    fn = _1.parallel(function (m) { return i++; }, function (m) { return i++; }, function (m) { return i++; });
                    _a = chai_1.expect;
                    return [4 /*yield*/, _1.readAll(fn({}))];
                case 1:
                    _a.apply(void 0, [_b.sent()]).to.eql([0, 1, 2]);
                    return [2 /*return*/];
            }
        });
    }); });
    it("Can handle a call that returns a rejection", function () { return __awaiter(_this, void 0, void 0, function () {
        var i, fn, error, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    i = 0;
                    fn = _1.parallel(function (m) { return i++; }, function (m) { return Promise.reject(new Error("some error")); });
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, _1.readAll(fn({}))];
                case 2:
                    _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    e_1 = _a.sent();
                    error = e_1;
                    return [3 /*break*/, 4];
                case 4:
                    chai_1.expect(error).not.to.be.undefined;
                    chai_1.expect(error.message).to.equal("some error");
                    return [2 /*return*/];
            }
        });
    }); });
    it("can nest parallel functions", function () { return __awaiter(_this, void 0, void 0, function () {
        var i, fn, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    i = 0;
                    fn = _1.parallel(_1.parallel(function (m) { return i++; }, function (m) { return i++; }, function (m) { return i++; }), function (m) { return i++; });
                    _a = chai_1.expect;
                    return [4 /*yield*/, _1.readAll(fn({}))];
                case 1:
                    _a.apply(void 0, [_b.sent()]).to.eql([0, 1, 2, 3]);
                    return [2 /*return*/];
            }
        });
    }); });
    it("can pass multiple arguments", function () { return __awaiter(_this, void 0, void 0, function () {
        var i, add, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    i = 0;
                    add = _1.parallel(function (a, b) { return a + b; }, function (a, b) { return a + b; });
                    _a = chai_1.expect;
                    return [4 /*yield*/, _1.readAll(add(1, 2))];
                case 1:
                    _a.apply(void 0, [_b.sent()]).to.eql([3, 3]);
                    return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=parallel-test.js.map